/*
 * Fachlicher Schlüssel für JPA Entität
 */
package de.ivu.elect.business.gebietsbaum.entity;

import de.ivu.elect.jee.faces.Messages;
import java.util.function.Function;

@javax.enterprise.inject.Vetoed
public class GebietsarteigenschaftTK
implements de.ivu.elect.jee.entity.tk.EntityTK, java.io.Serializable
  {

  private static final long serialVersionUID = 1L;

  private final int hashCode;

  protected final de.ivu.elect.business.gebietsbaum.entity.GebietsartTK gebietsartTK;
    public de.ivu.elect.business.gebietsbaum.entity.GebietsartTK getGebietsartTK(){
      return gebietsartTK;
    }
  protected final de.ivu.elect.business.wahl.entity.WahlartTK wahlartTK;
    public de.ivu.elect.business.wahl.entity.WahlartTK getWahlartTK(){
      return wahlartTK;
    }

  public GebietsarteigenschaftTK(
  de.ivu.elect.business.gebietsbaum.entity.GebietsartTK gebietsartTK
,   de.ivu.elect.business.wahl.entity.WahlartTK wahlartTK
  ) {
    super();


        this.gebietsartTK = gebietsartTK;
      this.wahlartTK = wahlartTK;
  
hashCode = calculateHashCode();
  }

  @Override
  public int hashCode(){
    return hashCode;
  }


  protected int calculateHashCode() {
        int result = 1;
    
    
        
                    result = result + ((gebietsartTK == null) ? 0 : gebietsartTK.hashCode());
                    result = result + ((wahlartTK == null) ? 0 : wahlartTK.hashCode());
            
    return result;
  }

  @Override
  public boolean equals(Object obj) {
    if (this == obj) {
      return true;
    }

    if (obj == null) {
      return false;
    }

    if (hashCode()!=obj.hashCode()) {
      return false;
    }


            
    if (getClass() != obj.getClass()) {
      if (!(obj instanceof GebietsarteigenschaftTK)) {
        return false;
      }

      if (!obj.getClass().isInstance(this)) {
        return obj.equals(this); // equals-Methode aus speziellerer Klasse verwenden
      }

    }

        GebietsarteigenschaftTK other = (GebietsarteigenschaftTK) obj;

        
                if (gebietsartTK == null) {
          if (other.gebietsartTK != null) {
            return false;
          }
        } else if (!gebietsartTK.equals(other.gebietsartTK)) {
          return false;
        }
                if (wahlartTK == null) {
          if (other.wahlartTK != null) {
            return false;
          }
        } else if (!wahlartTK.equals(other.wahlartTK)) {
          return false;
        }
            return true;
    
  }

  protected boolean hatAttribute() {
        return true;
      }

  @Override
  public String getEntityMessageKey() {
    return GebietsarteigenschaftConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getAllEntityFieldValues() {
    java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> result = new java.util.ArrayList<>();

    result.addAll(getEntityFieldValuesForEntity());
    result.addAll(gebietsartTK.getAllEntityFieldValues());
    result.addAll(wahlartTK.getAllEntityFieldValues());
    return result;
  }

  @Override
  public java.util.List<de.ivu.elect.jee.entity.tk.EntityFieldValue> getEntityFieldValuesForEntity() {
            return java.util.Collections.emptyList();
      }


            @Override
            public String toString() {
            return "GebietsarteigenschaftTK[" + toStringParameter() + "]";
            }



            protected String toStringParameter() {
            String result = ""

                                                    +"gebietsartTK="+gebietsartTK
                            +", wahlartTK="+wahlartTK
            
            ;
                            return result;
            
            }
  
  @Override
  public String toStringLokalisiert(Messages messages) {
    return messages.getMessageForMessageKey(getEntityMessageKey()) + " ["
    +  toStringLokalisiert(gebietsartTK, messages)
    + ", " +  toStringLokalisiert(wahlartTK, messages)
                + "]"

            ;
  }

            private String toStringLokalisiert(de.ivu.elect.jee.entity.tk.EntityTK entityTK, Messages messages) {
                if (entityTK != null) {
                    return entityTK.toStringLokalisiert(messages);
                }
                return null;
            }

            public static <E extends Gebietsarteigenschaft> java.util.Map<GebietsarteigenschaftTK, E> mappeGebietsarteigenschaftNachTK(java.util.Collection<E> entities) {
                return entities.stream().collect(java.util.stream.Collectors.toMap(Gebietsarteigenschaft::getGebietsarteigenschaftTK, Function.<E>identity(), (u,v)-> v));
                }


                public static Function<Gebietsarteigenschaft, GebietsarteigenschaftTK> getGebietsarteigenschaftToTKFunction() {
                return Gebietsarteigenschaft::getGebietsarteigenschaftTK;
                }

}
